%define		_builddir /usr/lib
Summary:	QT - Sources
Name: 		qt
Version:	3.3.8b
Release: 	1
License:	GPL and QPL
Group:		Libraries
URL:		http://www.troll.no/
Source0: 	ftp://ftp.trolltech.com/qt/source/qt-x11-free-%{version}.tar.bz2
Source1:	qtdesigner.desktop
Source2:	qtlinguist.desktop
Source3:	qtassistant.desktop
Source4:	qtconfig.desktop
Patch1: 	qt-3.1.1-fix-xft2-compile.patch
Patch2: 	qt-3.2.3-fix-cupslib.patch
Patch3: 	qt-3.3.2-active-aa-by-default.patch
Patch4: 	qt-x11-free-3.3.5-no-rpath.patch
Patch5: 	qt-3.3.2-fix-configure.patch
Patch7: 	qt-x11-free-3.3.5-fix-load-gl.patch
Patch8: 	qt-3.3.5-lib64-plugins.patch
Patch9: 	qt-x11-free-3.3.5-xpm-handling-fixes.patch
Patch10: 	qt-3.3.3-fix-accessible.patch
Patch11: 	qt-x11-free-3.3.6-qt-x11-immodule-unified-qt3.3.5-20060318-pre.patch
Patch12: 	fix-key-release-event-with-imm.diff
Patch13: 	qt-x11-free-3.3.6-lib64.patch
Patch14: 	qt-x11-free-3.3.4-linux32.patch
Patch15: 	qt-visibility.patch
Patch16: 	qt-x11-free-3.3.5-makelibshared.patch
Patch23: 	qt-x11-free-3.3.5-rubberband.patch
Patch24: 	qt-x11-free-3.3.5-qtranslator-crash.patch
Patch25: 	qt-x11-free-3.3.5-enable-designer-plugins.patch
Patch28: 	qt-x11-immodule-nodebug.diff
Patch29: 	fix-x11-immodule.diff
Patch30: 	fix-im-crash-on-exit.diff
Patch31: 	workaround-for-xlib-xim-bug.diff
Patch51: 	qt-x11-immodule-unified-qt3.3.7-20061229.diff
Patch52: 	qt-x11-free-3.3.6-qt-x11-immodule-unified-qt3.3.5-20060318-post.patch
Patch53: 	qt-x11-immodule-unified-qt3.3.5-20051012-quiet.patch
Patch54: 	qt3-xinerama-support.patch
Patch56: 	qt3-3.3.6-fix-xorg7.0.patch
Patch58: 	qt-3.3.6-fix-qfile-message-error.patch
Patch59: 	qt-3.3.6-fix-qfile-message-error2.patch
Patch60: 	qt3-3.3.8-fix-space.patch
Patch63: 	qt-x11-free-3.3.8-qmo35263.patch
#-------------- KDE qt-copy patches ( added the relevant ones )
Patch100: 	0005-qpixmap_mitshm.patch 
Patch101: 	0007-qpixmap_constants.patch 
Patch102: 	0017-qiconview-ctrl_rubber.patch 
Patch103: 	0032-fix_rotated_randr.diff 
Patch104: 	0035-qvaluelist-streaming-operator.patch 
Patch105: 	0038-dragobject-dont-prefer-unknown.patch 
Patch106: 	0044-qscrollview-windowactivate-fix.diff
Patch107: 	0047-fix-kmenu-width.diff
Patch108: 	0049-qiconview-rubber_on_move.diff
Patch109: 	0059-qpopup_has_mouse.patch
Patch110: 	0060-qpopup_ignore_mousepos.patch 
Patch111: 	0061-qscrollview-propagate-horizontal-wheelevent.patch 
Patch112: 	0073-xinerama-aware-qpopup.patch
Patch115: 	0078-argb-visual-hack.patch 
#-------------- My original lil patches ( maybe not even needed now? )
Patch116:	%{name}.diff
Patch117:	qapplication.cpp.diff
BuildRoot:      %{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Qt is a complete and well-designed multi-platform object-oriented framework for
developing graphical user interface (GUI) applications using C++. Qt has
seamless integration with OpenGL/Mesa 3D libraries.

Qt is free for development of free software on the X Window System. It includes
the complete source code for the X version and makefiles for Linux, Solaris,
SunOS, FreeBSD, OSF/1, Irix, BSD/OS, NetBSD, SCO, HP-UX and AIX. This edition
of Qt may be modified and distributed under the terms found in the LICENSE.QPL
file.

Qt also supports Windows 95 and NT, with native look and feel. Code developed
for the X version of Qt can be recompiled and run using the Windows 95/NT
version of Qt, and vice versa.

Qt is currently used in hundreds of software development projects world wide,
including the K Desktop Environment (see http://www.kde.org). For more
examples, see http://www.trolltech.com/qtprogs.html.

Qt has excellent documentation: around 750 pages of postscript and fully
cross-referenced online html documentation. It is available on the web:
http://doc.trolltech.com/

Qt is easy to learn, with consistent naming across all the classes and a
14-chapter on-line tutorial with links into the rest of the documentation.
A number of 3rd-party books are also available.

Qt dramatically cuts down on development time and complexity in writing
user interface software for the X Window System. It allows the programmer
to focus directly on the programming task, and not mess around with
low-level Motif/X11 code.

Qt is fully object-oriented. All widgets and dialogs are C++ objects,
and, using inheritance, creation of new widgets is easy and natural.

Qt's revolutionary signal/slot mechanism provides true component
programming. Reusable components can work together without any knowledge
of each other, and in a type-safe way.

Qt has a very fast paint engine, in some cases ten times faster than other
toolkits. The X version is based directly on Xlib and uses neither
Motif nor X Intrinsics.

Qt is available under two different licenses:
  - The Qt Professional Edition License, for developing fully commercial
    software: see http://www.trolltech.com/pricing.html
  - The Q Public License (QPL), for developing free softwar (X Window System
    only).

%package 	devel
Summary: 	Qt - Documentation and files needed to build Qt based applications
Group: 		Development

%description 	devel
Qt is a complete and well-designed multi-platform object-oriented framework for
developing graphical user interface (GUI) applications using C++. Qt has
seamless integration with OpenGL/Mesa 3D libraries.

Qt is free for development of free software on the X Window System. It includes
the complete source code for the X version and makefiles for Linux, Solaris,
SunOS, FreeBSD, OSF/1, Irix, BSD/OS, NetBSD, SCO, HP-UX and AIX. This edition
of Qt may be modified and distributed under the terms found in the LICENSE.QPL
file.

Qt also supports Windows 95 and NT, with native look and feel. Code developed
for the X version of Qt can be recompiled and run using the Windows 95/NT
version of Qt, and vice versa.

Qt is currently used in hundreds of software development projects world wide,
including the K Desktop Environment (see http://www.kde.org). For more
examples, see http://www.trolltech.com/qtprogs.html.

Qt has excellent documentation: around 750 pages of postscript and fully
cross-referenced online html documentation. It is available on the web:
http://doc.trolltech.com/

Qt is easy to learn, with consistent naming across all the classes and a
14-chapter on-line tutorial with links into the rest of the documentation.
A number of 3rd-party books are also available.

Qt dramatically cuts down on development time and complexity in writing
user interface software for the X Window System. It allows the programmer
to focus directly on the programming task, and not mess around with
low-level Motif/X11 code.

Qt is fully object-oriented. All widgets and dialogs are C++ objects,
and, using inheritance, creation of new widgets is easy and natural.

Qt's revolutionary signal/slot mechanism provides true component
programming. Reusable components can work together without any knowledge
of each other, and in a type-safe way.

Qt has a very fast paint engine, in some cases ten times faster than other
toolkits. The X version is based directly on Xlib and uses neither
Motif nor X Intrinsics.

Qt is available under two different licenses:
  - The Qt Professional Edition License, for developing fully commercial
    software: see http://www.trolltech.com/pricing.html
  - The Q Public License (QPL), for developing free softwar (X Window System
    only).

This package contains:
  - files needed to build Qt based applications
  - desginer, assistant and linguist applications
  - documentation, examples and tutorials

%prep
%setup -q -n qt
%patch1 -p1 -b .fix_xft_compile
%patch2 -p1 -b .fix_cups_lib
%patch3 -p1 -b .use_aa_by_default
%patch4 -p0 
%patch5 -p1 -b .fix_configure_space
#%patch6 -p1 -b .fix_unicode_font_cache
%patch7 -p0 -b .fix_opengl
%patch13 -p1 -b .lib64
%patch14 -p1 -b .linux32
%patch9 -p0 -b .xpm_handling
%patch10 -p1 -b .fix_accessible
# -- build Immodule patches
%patch11 -p1 -b .add_support_for_qt_immodule
%patch51 -p1 -b .diff_immodule
%patch52 -p1 -b .post_immodule
%patch53 -p1 -b .fix
# -- end of Immodule patches
%patch15 -p1 -b .fix_qt_export
%patch16 -p1 -b .sharedlibs
%patch23 -p0 -b .rubberband
%patch24 -p0 -b .qtranslator
%patch25 -p0 -b .designer_plugins
%patch54 -p1 -b .fix_xinerama
%patch56 -p1 -b .fix_xorg_7.0
%patch58 -p1 -b .fix_qfile_message_error
%patch59 -p1 -b .fix_qfile_message_error
%patch60 -p1 -b .fix_space
%patch63 -p0 -b .fix_bug_35263
# KDE qt-copy patches
%patch100 -p0 -b .qt-copy
%patch101 -p0 -b .qt-copy
%patch102 -p0 -b .qt-copy
%patch103 -p0 -b .qt-copy
%patch104 -p0 -b .qt-copy
%patch105 -p0 -b .qt-copy
%patch106 -p0 -b .qt-copy
%patch107 -p0 -b .qt-copy
%patch108 -p0 -b .qt-copy
%patch109 -p0 -b .qt-copy
%patch110 -p0 -b .qt-copy
%patch111 -p0 -b .qt-copy
%patch112 -p0 -b .qt-copy
%patch115 -p0 -b .qt-copy
# My lil farts
%patch116 -p0
%patch117 -p0
#rm include/{qmotif.h,qmotifdialog.h,qmotifwidget.h,qxtwidget.h}

%build
export QTDIR=$(/bin/pwd)
export PATH=$QTDIR/bin:$PATH
export MANPATH=$QTDIR/doc/man:$MANPATH
export LD_LIBRARY_PATH=$QTDIR/lib:$LD_LIBRARY_PATH
sh ./make-symlinks.sh
echo yes | sh ./configure \
	    -fast \
	    -shared \
	    -enable-opengl \
	    -system-libpng \
	    -system-libjpeg \
	    -system-libmng \
	    -thread \
	    -qt-gif \
	    -system-zlib \
            -release \
	    -no-nas-sound \
	    -no-g++-exceptions \
	    -platform linux-g++ \
            -enable-tools \
            -enable-kernel \
	    -enable-widgets \
	    -enable-dialogs \
	    -enable-iconview \
	    -enable-workspace \
            -enable-network \
	    -enable-canvas \
	    -enable-table \
	    -enable-xml \
	    -enable-sql \
	    -qt-sql-mysql \
	    -plugin-sql-mysql \
	    -qt-imgfmt-png \
	    -qt-imgfmt-jpeg \
	    -qt-imgfmt-mng \
	    -sm \
	    -xinerama \
	    -xrender \
	    -xft \
	    -no-tablet \
	    -no-stl
make CC="gcc $RPM_OPT_FLAGS"

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT/usr/lib/qt
mkdir -p $RPM_BUILD_ROOT/usr/lib/qt/{bin,include,plugins,lib,doc,mkspecs}
mkdir -p $RPM_BUILD_ROOT/usr/lib/qt/include/private
mkdir -p $RPM_BUILD_ROOT/usr/lib/pkgconfig
mkdir -p $RPM_BUILD_ROOT/usr/bin
mkdir -p $RPM_BUILD_ROOT/usr/doc
cp -r lib/* $RPM_BUILD_ROOT/usr/lib/qt/lib
cp -r plugins/* $RPM_BUILD_ROOT/usr/lib/qt/plugins
cp -r doc/* $RPM_BUILD_ROOT/usr/lib/qt/doc
cp -r mkspecs/{linux*,default} $RPM_BUILD_ROOT/usr/lib/qt/mkspecs
cp -H include/*.h $RPM_BUILD_ROOT/usr/lib/qt/include/
cp -H include/private/*.h $RPM_BUILD_ROOT/usr/lib/qt/include/private/
cp -H bin/* $RPM_BUILD_ROOT/usr/lib/qt/bin
mkdir -p $RPM_BUILD_ROOT/usr/lib/pkgconfig; cd $RPM_BUILD_ROOT/usr/lib/pkgconfig; ln -sf ../qt-mt.pc .
cd $RPM_BUILD_ROOT/usr/doc; ln -sf ../lib/qt/doc qt-html
cd ../bin; cp -s ../lib/qt/bin/* ./; rm $RPM_BUILD_ROOT/usr/lib/qt/lib/README
cd ../lib; cp -s qt/lib/* ./
cd -
mkdir -p $RPM_BUILD_ROOT/usr/share/peanut/apps/Applications/Development/qt
cp %{SOURCE1} %{SOURCE2} %{SOURCE3} %{SOURCE4} $RPM_BUILD_ROOT/usr/share/peanut/apps/Applications/Development/qt


strip -R.comment -R.note $RPM_BUILD_ROOT/usr/lib/qt/*.so 2>/dev/null || :
strip -R.comment -R.note $RPM_BUILD_ROOT/usr/lib/qt/bin/* 2>/dev/null || :

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root)
/usr/lib/qt/lib/*.so.*
/usr/lib/qt/lib/*.prl
/usr/lib/qt/lib/*.so
/usr/lib/qt/lib/*.la
/usr/lib/*.so.*
/usr/lib/*.so
/usr/lib/*.la
/usr/lib/*.prl

%files devel
%defattr(-,root,root)
#/usr/lib/qt/lib/*.a
/usr/lib/qt/lib/*.pc
#/usr/lib/*.a
/usr/lib/*.pc
/usr/lib/qt/bin
/usr/lib/qt/plugins
/usr/lib/qt/include
/usr/lib/qt/mkspecs
/usr/lib/pkgconfig
/usr/lib/qt/doc
/usr/share
/usr/doc
/usr/bin
